grammar ExpressionGrammar;

// parser

expr  : left=expr op=('*'|'/') right=expr #opExpr
      | left=expr op=('+'|'-') right=expr #opExpr
      | '(' expr ')'                      #parenExpr
      | atom=INT                          #atomExpr
      ;
 
// lexer
 
INT : ('0' .. '9') +;
 
WS : [ \r\n\t] + -> skip ;